import * as tls from 'tls';
export interface HttpsProxyConfig extends tls.ConnectionOptions {
    headers?: {
        [key: string]: string;
    };
    auth?: string;
}
export interface ConnectionOptions {
    host: string;
    port: number;
}
/**
 * The `HttpsProxyAgent` implements an HTTP Agent subclass that connects to the
 * specified "HTTP(s) proxy server" in order to proxy HTTPS requests.
 *
 * @api public
 */
export declare class HttpsProxySocket {
    proxy: tls.ConnectionOptions;
    proxyConfig: HttpsProxyConfig;
    constructor(opts: tls.ConnectionOptions | string, proxyConfig?: HttpsProxyConfig);
    /**
     * Create a new Socket connection.
     *
     * @param opts - hostname and port
     */
    connect(opts: ConnectionOptions): Promise<tls.TLSSocket>;
    private _connect;
}
