"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const debug = require('debug')('https-proxy');
/**
 * Replace the connection method on the tedious library (used by mssql)
 * to connect via a proxy.
 *
 * @param proxy - the proxy to use
 */
function useProxy(proxy) {
    const { Connector } = require('tedious/lib/connector');
    Connector.prototype.execute = function (cb) {
        return __awaiter(this, void 0, void 0, function* () {
            debug(`opening sql connection to ${this.options.host}:${this.options.port}`);
            proxy.connect(this.options).then(socket => {
                cb(null, socket);
            }, error => {
                cb(error);
            });
        });
    };
}
exports.useProxy = useProxy;
